from django.utils.translation import ugettext as _
from oidc_provider.lib.claims import ScopeClaims


class AuraScopeClaims(ScopeClaims):

    info_username = (
        _(u'username'),
        _(u'Your username.'),
    )

    def scope_username(self):
        dic = {
            'username': self.user.username
        }

        return dic

    info_aura_shows = (
        _(u'AURA Shows'),
        _(u'AURA shows you have access to.'),
    )

    def scope_aura_shows(self):
        show_slugs = list(self.user.shows.all().values_list('slug', flat=True))
        dic = {
            'shows': show_slugs
        }

        return dic
